<?php

require("/usr/share/bm-stats/www/conf/config.php");
require("/usr/share/bm-stats/www/function/dir_file.php");
require("/usr/share/bm-stats/www/function/lang.php");

function get_H12Values($domain) {

    Global $path_to_data ;

    $thisArray = array() ;
    $this_file = $path_to_data.$domain."/realTime.dat" ;


    $val = file($this_file) ;
    sort($val) ;
    
    foreach($val as $key=>$line) {
        
        $thisArray['x'][$key] = "";
        $thisLine = str_replace("\n","",$line) ;

        $values = explode(";",$thisLine); 
        $mktime =  $values[0] ;
            $hour = date("H",$mktime) ;
            $min  = date("i",$mktime) ;

            if($min == '00') {
                $thisArray['x'][$key] = "$hour:00" ;
            };

        $counters = explode(",",$values[1]) ;
        
        $thisArray['nbT'][]  = $counters[0];
        $thisArray['nbt'][]  = $counters[1];
        $thisArray['volT'][] = round($counters[2]/1000000);
        $thisArray['volt'][] = round($counters[3]/1000000);
        $thisArray['nbf'][]  = "-".$counters[4];
        $thisArray['volf'][] = "-".round($counters[5]/1000000);

    };    

    return $thisArray ;

} ;

/**
do_H12Graph(&$thisArray,$case)
create an image from counters stored in "/var/lib/bm-stats/[domain]/realTime.dat"
ARGS :
&$thisArray : array of values returned by get_H12Values()
$case       : could be NB/VOL

**/


function do_H12GraphIn(&$thisArray,$case,$domain) {

    Global $l_H12_title_NB, $l_H12_title_VOL;
    Global $l_H12_incoming_NB, $l_H12_incoming_VOL;
    Global $l_H12_outgoing_NB, $l_H12_outgoing_VOL;
    Global $l_H12_AxisName_incoming, $l_H12_AxisName_outgoing ;
    Global $path_to_data ; 


    $path_to_pChart = "/usr/share/bm-stats/scripts/PHP/pChart/" ;


    require_once($path_to_pChart."class/pData.class.php");
    require_once($path_to_pChart."class/pDraw.class.php");
    require_once($path_to_pChart."class/pImage.class.php");


    verif_existence_rep($path_to_data.$domain."/img");


    if( $case == "NB" ) {
        
        $y1 = $thisArray['nbT'] ; 
        $y2 = $thisArray['nbf'] ;

        $y1_title= $l_H12_incoming_NB;
        $y2_title= $l_H12_outgoing_NB;
        $title = $domain." : ".$l_H12_title_NB;

        $img = $path_to_data.$domain."/img/H12_NB.png";

    };

    if( $case == "VOL" ) {
                   
        $y1 = $thisArray['volT'] ;
        $y2 = $thisArray['volf'] ;

        $y1_title= $l_H12_incoming_VOL;
        $y2_title= $l_H12_outgoing_VOL;
        $title = $domain." : ".$l_H12_title_VOL;

        $img = $path_to_data.$domain."/img/H12_VOL.png";
    };

    $x = $thisArray['x'] ;


    $MyData = new pData();  
    $MyData->addPoints($y1,$y1_title);
    $MyData->addPoints($y2,$y2_title);
    $MyData->addPoints($x,"X");

    $MyData->setAbscissa("X");
    


    $MyData->setAxisName(0,"(-) $l_H12_AxisName_outgoing / (+) $l_H12_AxisName_incoming");

    #$y1_colorscheme = array("R"=>15,"G"=>44,"B"=>52,"Alpha"=>80);
    $y1_colorscheme = array("R"=>0, "G"=>75,"B"=>123,"Alpha"=>80);
    $MyData->setPalette($y1_title,$y1_colorscheme);

    #$y2_colorscheme = array("R"=>184,"G"=>0,"B"=>40,"Alpha"=>80);
    $y2_colorscheme = array("R"=>200,"G"=>40,"B"=>40,"Alpha"=>80);
    $MyData->setPalette($y2_title,$y2_colorscheme);

  
    $myPicture = new pImage(1200,300,$MyData);

    $myPicture->drawGradientArea(0,0,1200,300,DIRECTION_VERTICAL,array("StartR"=>166,"StartG"=>202,"StartB"=>219,"EndR"=>0,"EndG"=>75,"EndB"=>123,"Alpha"=>100));   
    #$myPicture->drawGradientArea(0,280,1200,300,DIRECTION_VERTICAL,array("StartR"=>0,"StartG"=>75,"StartB"=>123,"EndR"=>166,"EndG"=>202,"EndB"=>219,"Alpha"=>100));




    #$myPicture->drawLine(0,279,1200,279,array("R"=>0,"G"=>0,"B"=>0));
    #$myPicture->drawLine(0,280,1200,280,array("R"=>70,"G"=>70,"B"=>70));

    /* Add a border to the picture */
    $myPicture->drawRectangle(0,0,1199,299,array("R"=>204,"G"=>204,"B"=>204));

    /* Write the picture title */
    $myPicture->setFontProperties(array("FontName"=>$path_to_pChart."fonts/DejaVuSansMono-Bold.ttf","FontSize"=>10));
    $myPicture->drawText(600,14,$title,array("R"=>47,"G"=>47,"B"=>47,"Align"=>TEXT_ALIGN_MIDDLEMIDDLE));

    
    $myPicture->setFontProperties(array("FontName"=>$path_to_pChart."fonts/verdana.ttf","FontSize"=>8));
    /* Define the chart area */
    $myPicture->setGraphArea(48,27,1180,258);

    $ScaleSettings = array("Mode"=>SCALE_MODE_ADDALL, 
                            "XMargin"=>20,
                            "DrawXLines"=>FALSE,
                            "DrawSubTicks"=>TRUE,
                            "GridR"=>0,"GridG"=>0,"GridB"=>0,
                            "AxisR"=>0,"AxisG"=>0,"AxisB"=>0,
                            "GridAlpha"=>30,
                            "CycleBackground"=>TRUE,
                            "DrawArrows"=>TRUE,
                            "ArrowSize"=> 5 ,
                            );
    
    $myPicture->drawScale($ScaleSettings);
    $myPicture->setShadow(TRUE,array("X"=>1,"Y"=>1,"R"=>0,"G"=>0,"B"=>0,"Alpha"=>10));
    $myPicture->drawStackedBarChart(array("DisplayColor"=>DISPLAY_AUTO));

    if( $case == "VOL" ) {
        /* Write Mo */
        $myPicture->setFontProperties(array("FontName"=>$path_to_pChart."fonts/DejaVuSansMono-Bold.ttf","FontSize"=>11));
        $myPicture->drawText(50,15,"Mo",array("R"=>0,"G"=>0,"B"=>0));
    };

    /* Write the Service*/
    $myPicture->setFontProperties(array("FontName"=>$path_to_pChart."fonts/verdana.ttf","FontSize"=>8));
    $myPicture->drawText(1050,295,"[ ".date("d/m/Y H:i:s")." ] ",array("R"=>255,"G"=>255,"B"=>255));
    $myPicture->drawFromPNG(5,252,"/usr/share/bm-stats/scripts/PHP/do_graph/logo-bluemind.png");

    $myPicture->setShadow(FALSE);
      
      
    $myPicture->Render($img);

};


function get_domainList() {

    Global $path_to_data;

    $noThis = array(".","..","general");
    $thisDomainList = array() ;
   
    if ($handle = opendir($path_to_data)) {
        while(false !== ($entry = readdir($handle))) {
            
            if(!in_array($entry,$noThis)) {
                
                if(is_file($path_to_data."/".$entry."/realTime.dat")) {
                    $thisDomainList[] = $entry;
                };
            };
        }; 
      
        closedir($handle);                                                                        
    };    
    
    return $thisDomainList ;
};  

/*  */

$thisDomainList = get_domainList() ;

foreach ($thisDomainList as $domain) {

    $myLang = getLang($domain) ;
    if(!empty($myLang)) $lang=$myLang ;

    require("/usr/share/bm-stats/www/inc_lang/inc_lang_$lang.php");

    
    
    if(file($path_to_data.$domain."/realTime.dat")) {
        $thisValues = get_H12Values($domain) ;
      
        if(!empty($thisValues['nbT'])) do_H12GraphIn($thisValues,"NB",$domain) ;    
        if(!empty($thisValues['volT'])) do_H12GraphIn($thisValues,"VOL",$domain) ;

    };

};



?>
